请判断一个链表是否为回文链表。

**示例 1:**
```
输入: 1->2
输出: false
```
**示例 2:**
```
输入: 1->2->2->1
输出: true
```
**进阶：**
- 你能否用 `O(n)` 时间复杂度和 `O(1)` 空间复杂度解决此题？

通过次数`141,334`&ensp;|&ensp;提交次数`322,133`

**代码实现**

- `O(n)` 时间复杂度和 `O(n)` 空间复杂度
```python
# Definition for singly-linked list.
class ListNode:
    def __init__(self, x):
        self.val = x
        self.next = None

class Solution:
    def isPalindrome(self, head: ListNode) -> bool:
        stack = []
        while head:
            stack.append(head.val)
            head = head.next
        for i in range(len(stack)//2):
            if stack[i]!=stack[len(stack)-i-1]:
                return False
        return True
```
- `O(n)` 时间复杂度和 `O(1)` 空间复杂度
```python
# Definition for singly-linked list.
class ListNode:
    def __init__(self, x):
        self.val = x
        self.next = None

class Solution:
    def isPalindrome(self, head: ListNode) -> bool:
        fast, slow, Trans = head, head, None
        while fast and fast.next and slow:
            cur = slow
            slow = slow.next
            fast = fast.next.next
            cur.next = Trans
            Trans = cur
        if fast:
            slow = slow.next
        while slow and Trans:
            if slow.val!=Trans.val:
                return False
            slow = slow.next
            Trans = Trans.next
        return True
```
```
来源：力扣（LeetCode）
链接：https://leetcode-cn.com/problems/palindrome-linked-list
著作权归领扣网络所有。商业转载请联系官方授权，非商业转载请注明出处。
```
