给你一个数组 `nums`，对于其中每个元素 `nums[i]`，请你统计数组中比它小的所有数字的数目。

换而言之，对于每个 `nums[i]` 你必须计算出有效的` j `的数量，其中 `j` 满足` j != i` 且 `nums[j] < nums[i] `。

以数组形式返回答案。

**示例 1：**
```
输入：nums = [8,1,2,2,3]
输出：[4,0,1,1,3]
解释： 
对于 nums[0]=8 存在四个比它小的数字：（1，2，2 和 3）。 
对于 nums[1]=1 不存在比它小的数字。
对于 nums[2]=2 存在一个比它小的数字：（1）。 
对于 nums[3]=2 存在一个比它小的数字：（1）。 
对于 nums[4]=3 存在三个比它小的数字：（1，2 和 2）。
```

**示例 2：**
```
输入：nums = [6,5,4,8]
输出：[2,1,0,3]
```

**示例 3：**
```
输入：nums = [7,7,7,7]
输出：[0,0,0,0]
```

**提示：**

-  `2 <= nums.length <= 500`
-  `0 <= nums[i] <= 100`

通过次数`34,552`&ensp;|&ensp;提交次数`41,888`

**代码实现**

```python
class Solution:
    def smallerNumbersThanCurrent(self, nums: List[int]) -> List[int]:
        import bisect
        temp = nums.copy()
        nums.sort()
        re = []
        for i in temp:
            idx = bisect.bisect_left(nums, i)
            re.append(idx)
        return re
```
- 更高效解法

```python
class Solution:
    def smallerNumbersThanCurrent(self, nums: List[int]) -> List[int]:
        mx = max(nums)
        count = [0]*(mx+1)
        for i in nums:
            count[i]+=1
        for i in range(1, mx+1):
            count[i]+=count[i-1]
        re = []
        for i in nums:
            if i>0:
                re.append(count[i-1])
            else:
                re.append(0)
        return re
```
```
来源：力扣（LeetCode）
链接：https://leetcode-cn.com/problems/how-many-numbers-are-smaller-than-the-current-number
著作权归领扣网络所有。商业转载请联系官方授权，非商业转载请注明出处。
```